// Generated by 'peg2'
// https://pub.dev/packages/peg2

import 'package:peg2/grammar.dart';
import 'package:peg2/expressions.dart';

int _escape(int c) {
  switch (c) {
    case 110:
      return 0xA;
    case 114:
      return 0xD;
    case 116:
      return 0x9;
  }

  return c;
}

Expression _prefix(String prefix, Expression expression, String variable) {
  switch (prefix) {
    case '&':
      expression = AndPredicateExpression(expression);
      break;
    case '!':
      expression = NotPredicateExpression(expression);
      break;
  }

  expression.variable = variable;
  return expression;
}

Expression _suffix(String suffix, Expression expression) {
  switch (suffix) {
    case '?':
      return OptionalExpression(expression);
    case '*':
      return ZeroOrMoreExpression(expression);
    case '+':
      return OneOrMoreExpression(expression);
  }

  return expression;
}

class Peg2Parser {
  static const _eof = 0x110000;

  FormatException error;

  int _c;

  List<String> _failures;

  int _fcount;

  int _fposEnd;

  int _fposMax;

  int _fposStart;

  List<int> _input;

  List<bool> _memoizable;

  List<List<_Memo>> _memos;

  var _mresult;

  int _pos;

  bool _predicate;

  dynamic _result;

  bool _silence;

  bool _success;

  String _text;

  List<int> _trackCid;

  List<int> _trackPos;

  dynamic parse(String text) {
    if (text == null) {
      throw ArgumentError.notNull('text');
    }
    _text = text;
    _input = _toRunes(text);
    _reset();
    final result = _parseGrammar(0, true);
    _buildError();
    _failures = null;
    _input = null;
    return result;
  }

  void _buildError() {
    if (_success) {
      error = null;
      return;
    }

    String escape(int c) {
      switch (c) {
        case 10:
          return r'\n';
        case 13:
          return r'\r';
        case 09:
          return r'\t';
        case _eof:
          return 'end of file';
      }
      return String.fromCharCode(c);
    }

    String getc(int position) {
      if (position < _text.length) {
        return "'${escape(_input[position])}'";
      }
      return 'end of file';
    }

    String report(String message, String source, int start) {
      if (start < 0 || start > source.length) {
        start = null;
      }

      final sb = StringBuffer();
      sb.write(message);
      var line = 0;
      var col = 0;
      var lineStart = 0;
      var started = false;
      if (start != null) {
        for (var i = 0; i < source.length; i++) {
          final c = source.codeUnitAt(i);
          if (!started) {
            started = true;
            lineStart = i;
            line++;
            col = 1;
          } else {
            col++;
          }
          if (c == 10) {
            started = false;
          }
          if (start == i) {
            break;
          }
        }
      }

      if (start == null) {
        sb.writeln('.');
      } else if (line == 0 || start == source.length) {
        sb.writeln(' (at end of file):');
      } else {
        sb.write(' (at line ');
        sb.write(line);
        sb.write(', column ');
        sb.write(col);
        sb.writeln('):');
      }

      List<int> escape(int c) {
        switch (c) {
          case 9:
            return [92, 116];
          case 10:
            return [92, 110];
          case 13:
            return [92, 114];
          default:
            return [c];
        }
      }

      const max = 70;
      if (start != null) {
        final c1 = <int>[];
        final c2 = <int>[];
        final half = max ~/ 2;
        var cr = false;
        for (var i = start; i >= lineStart && c1.length < half; i--) {
          if (i == source.length) {
            c2.insert(0, 94);
          } else {
            final c = source.codeUnitAt(i);
            final escaped = escape(c);
            c1.insertAll(0, escaped);
            if (c == 10) {
              cr = true;
            }

            var r = i == start ? 94 : 32;
            for (var k = 0; k < escaped.length; k++) {
              c2.insert(0, r);
            }
          }
        }

        for (var i = start + 1;
            i < source.length && c1.length < max && !cr;
            i++) {
          final c = source.codeUnitAt(i);
          final escaped = escape(c);
          c1.addAll(escaped);
          if (c == 10) {
            break;
          }
        }

        var text1 = String.fromCharCodes(c1);
        var text2 = String.fromCharCodes(c2);
        sb.writeln(text1);
        sb.writeln(text2);
      }

      return sb.toString();
    }

    final temp = _failures.take(_fcount).toList();
    temp.sort((e1, e2) => e1.compareTo(e2));
    final terminals = temp.toSet();
    final hasMalformed = _fposStart != _fposMax;
    if (terminals.isNotEmpty) {
      if (!hasMalformed) {
        final sb = StringBuffer();
        sb.write('Expected ');
        sb.write(terminals.join(', '));
        sb.write(' but found ');
        sb.write(getc(_fposStart));
        final title = sb.toString();
        final message = report(title, _text, _fposStart);
        error = FormatException(message);
      } else {
        final reason = _fposMax == _text.length ? 'Unterminated' : 'Malformed';
        final sb = StringBuffer();
        sb.write(reason);
        sb.write(' ');
        sb.write(terminals.join(', '));
        final title = sb.toString();
        final message = report(title, _text, _fposStart);
        error = FormatException(message);
      }
    } else {
      final sb = StringBuffer();
      sb.write('Unexpected character ');
      sb.write(getc(_fposStart));
      final title = sb.toString();
      final message = report(title, _text, _fposStart);
      error = FormatException(message);
    }
  }

  void _fail(int start, String name) {
    if (_fposStart < start) {
      _fposStart = start;
      _fposMax = _fposEnd;
      _fcount = 0;
    } else if (_fposMax < _fposEnd) {
      _fposStart = start;
      _fposMax = _fposEnd;
      _fcount = 0;
    }

    if (_fposStart == start && _fposEnd == _fposMax) {
      if (_fcount >= _failures.length) {
        _failures.length += 20;
      }

      _failures[_fcount++] = name;
    }
  }

  int _matchRanges(List<int> ranges) {
    int result;
    _success = false;
    for (var i = 0; i < ranges.length; i += 2) {
      if (ranges[i] <= _c) {
        if (ranges[i + 1] >= _c) {
          result = _c;
          _c = _input[_pos += _c <= 0xffff ? 1 : 2];
          _success = true;
          break;
        }
      } else {
        break;
      }
    }

    if (!_success && !_silence && _fposEnd < _pos) {
      _fposEnd = _pos;
    }

    return result;
  }

  String _matchString(String text) {
    String result;
    final length = text.length;
    final rest = _text.length - _pos;
    final count = length > rest ? rest : length;
    var pos = _pos;
    var i = 0;
    for (; i < count; i++, pos++) {
      if (text.codeUnitAt(i) != _text.codeUnitAt(pos)) {
        break;
      }
    }

    if (i == length) {
      _c = _input[_pos += length];
      _success = true;
      result = text;
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos + i;
      }
    }

    return result;
  }

  bool _memoized(int id, int cid) {
    final memos = _memos[_pos];
    if (memos != null) {
      for (var i = 0; i < memos.length; i++) {
        final memo = memos[i];
        if (memo.id == id) {
          _pos = memo.pos;
          _mresult = memo.result;
          _success = memo.success;
          _c = _input[_pos];
          return true;
        }
      }
    }

    if (_memoizable[cid] != null) {
      return false;
    }

    var lastCid = _trackCid[id];
    var lastPos = _trackPos[id];
    _trackCid[id] = cid;
    _trackPos[id] = _pos;
    if (lastCid == null) {
      return false;
    }

    if (lastPos == _pos) {
      if (lastCid != cid) {
        _memoizable[lastCid] = true;
        _memoizable[cid] = false;
      }
    }

    return false;
  }

  void _memoize(int id, int pos, result) {
    var memos = _memos[pos];
    if (memos == null) {
      memos = [];
      _memos[pos] = memos;
    }

    final memo = _Memo(
      id: id,
      pos: _pos,
      result: result,
      success: _success,
    );

    memos.add(memo);
  }

  void _reset() {
    _c = _input[0];
    _failures = [];
    _failures.length = 20;
    _fcount = 0;
    _fposEnd = -1;
    _fposMax = -1;
    _fposStart = -1;
    _memoizable = [];
    _memoizable.length = 444;
    _memos = [];
    _memos.length = _input.length + 1;
    _pos = 0;
    _predicate = false;
    _silence = false;
    _trackCid = [];
    _trackCid.length = 444;
    _trackPos = [];
    _trackPos.length = 444;
  }

  List<int> _toRunes(String source) {
    final length = source.length;
    final result = List<int>(length + 1);
    for (var pos = 0; pos < length;) {
      int c;
      final start = pos;
      final leading = source.codeUnitAt(pos++);
      if ((leading & 0xFC00) == 0xD800 && pos < length) {
        final trailing = source.codeUnitAt(pos);
        if ((trailing & 0xFC00) == 0xDC00) {
          c = 0x10000 + ((leading & 0x3FF) << 10) + (trailing & 0x3FF);
          pos++;
        } else {
          c = leading;
        }
      } else {
        c = leading;
      }

      result[start] = c;
    }

    result[length] = 0x110000;
    return result;
  }

  Grammar _parseGrammar(int $0, bool $1) {
    Grammar $2;
    var $4 = _c;
    var $5 = _pos;
    var $7 = _silence;
    _silence = true;
    _parse_leading_spaces(3, false);
    _success = true;
    _silence = $7;
    var $9 = _silence;
    _silence = true;
    var $10 = _parse_globals(5, $1);
    _success = true;
    _silence = $9;
    var $11 = _silence;
    _silence = true;
    var $12 = _parse_members(7, $1);
    _success = true;
    _silence = $11;
    List<ProductionRule> $13;
    if ($1) {
      $13 = [];
    }
    var $14 = false;
    for (;;) {
      var $15 = _parseDefinition(9, $1);
      if (!_success) {
        _success = $14;
        if (!_success) {
          $13 = null;
        }
        break;
      }
      if ($1) {
        $13.add($15);
      }
      $14 = true;
    }
    if (_success) {
      _parse_end_of_file(10, false);
      if (_success) {
        var g = $10;
        var m = $12;
        var d = $13;
        Grammar $$;
        $$ = Grammar(d, g, m);
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
    }
    return $2;
  }

  ProductionRule _parseDefinition(int $0, bool $1) {
    ProductionRule $2;
    var $4 = _c;
    var $5 = _pos;
    for (;;) {
      $2 = _parseNonterminalDefinition(13, $1);
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      $2 = _parseTerminalDefinition(15, $1);
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      $2 = _parseSubterminalDefinition(17, $1);
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  ProductionRule _parseNonterminalDefinition(int $0, bool $1) {
    ProductionRule $2;
    var $4 = _c;
    var $5 = _pos;
    for (;;) {
      var $7 = _parseType(20, $1);
      if (_success) {
        var $8 = _parse_non_terminal_name(21, $1);
        if (_success) {
          _parse_$EqualSign(22, false);
          if (_success) {
            var $10 = _parseNonterminalExpression(23, $1);
            if (_success) {
              _parse_$Semicolon(24, false);
              if (_success) {
                var t = $7;
                var n = $8;
                var e = $10;
                ProductionRule $$;
                $$ = ProductionRule(n, ProductionRuleKind.nonterminal, e, t);
                $2 = $$;
              }
            }
          }
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      var $13 = _parse_non_terminal_name(26, $1);
      if (_success) {
        _parse_$EqualSign(27, false);
        if (_success) {
          var $15 = _parseNonterminalExpression(28, $1);
          if (_success) {
            _parse_$Semicolon(29, false);
            if (_success) {
              var n = $13;
              var e = $15;
              ProductionRule $$;
              $$ = ProductionRule(n, ProductionRuleKind.nonterminal, e, null);
              $2 = $$;
            }
          }
        }
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  OrderedChoiceExpression _parseNonterminalExpression(int $0, bool $1) {
    if (_memoized(30, $0)) {
      return _mresult as OrderedChoiceExpression;
    }
    var $2 = _pos;
    OrderedChoiceExpression $3;
    var $5 = _c;
    var $6 = _pos;
    var $8 = _parseNonterminalSequence(32, $1);
    if (_success) {
      List<SequenceExpression> $9;
      var $10 = _silence;
      _silence = true;
      if ($1) {
        $9 = [];
      }
      for (;;) {
        SequenceExpression $11;
        var $12 = _c;
        var $13 = _pos;
        _parse_$Slash(36, false);
        if (_success) {
          $11 = _parseNonterminalSequence(37, $1);
        }
        if (!_success) {
          _c = $12;
          _pos = $13;
          break;
        }
        if ($1) {
          $9.add($11);
        }
      }
      _success = true;
      _silence = $10;
      if (_success) {
        var e = $8;
        var n = $9;
        OrderedChoiceExpression $$;
        $$ = OrderedChoiceExpression([e, ...n]);
        $3 = $$;
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    }
    if (_memoizable[$0] == true) {
      _memoize(30, $2, $3);
    }
    return $3;
  }

  SequenceExpression _parseNonterminalSequence(int $0, bool $1) {
    if (_memoized(38, $0)) {
      return _mresult as SequenceExpression;
    }
    var $2 = _pos;
    SequenceExpression $3;
    var $5 = _c;
    var $6 = _pos;
    List<Expression> $8;
    if ($1) {
      $8 = [];
    }
    var $9 = false;
    for (;;) {
      var $10 = _parseNonterminalPrefix(41, $1);
      if (!_success) {
        _success = $9;
        if (!_success) {
          $8 = null;
        }
        break;
      }
      if ($1) {
        $8.add($10);
      }
      $9 = true;
    }
    if (_success) {
      var $11 = _silence;
      _silence = true;
      var $12 = _parse_action(43, $1);
      _success = true;
      _silence = $11;
      if (_success) {
        var e = $8;
        var a = $12;
        SequenceExpression $$;
        $$ = SequenceExpression(e, a);
        $3 = $$;
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    }
    if (_memoizable[$0] == true) {
      _memoize(38, $2, $3);
    }
    return $3;
  }

  Expression _parseNonterminalPrefix(int $0, bool $1) {
    Expression $2;
    var $4 = _c;
    var $5 = _pos;
    var $7 = _silence;
    _silence = true;
    var $8 = _parse_semantic_value(47, $1);
    _success = true;
    _silence = $7;
    var $9 = _silence;
    _silence = true;
    String $10;
    var $11 = _c;
    var $12 = _pos;
    for (;;) {
      $10 = _parse_$Ampersand(51, $1);
      if (_success) {
        break;
      } else {
        _c = $11;
        _pos = $12;
      }
      $10 = _parse_$ExclamationMark(53, $1);
      if (_success) {
      } else {
        _c = $11;
        _pos = $12;
      }
      break;
    }
    _success = true;
    _silence = $9;
    var $17 = _parseNonterminalSuffix(54, $1);
    if (_success) {
      var s = $8;
      var p = $10;
      var e = $17;
      Expression $$;
      $$ = _prefix(p, e, s);
      $2 = $$;
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
    }
    return $2;
  }

  Expression _parseNonterminalSuffix(int $0, bool $1) {
    Expression $2;
    var $4 = _c;
    var $5 = _pos;
    var $7 = _parseNonterminalPrimary(57, $1);
    if (_success) {
      var $8 = _silence;
      _silence = true;
      String $9;
      var $10 = _c;
      var $11 = _pos;
      for (;;) {
        $9 = _parse_$QuestionMark(61, $1);
        if (_success) {
          break;
        } else {
          _c = $10;
          _pos = $11;
        }
        $9 = _parse_$Asterisk(63, $1);
        if (_success) {
          break;
        } else {
          _c = $10;
          _pos = $11;
        }
        $9 = _parse_$PlusSign(65, $1);
        if (_success) {
        } else {
          _c = $10;
          _pos = $11;
        }
        break;
      }
      _success = true;
      _silence = $8;
      if (_success) {
        var e = $7;
        var s = $9;
        Expression $$;
        $$ = _suffix(s, e);
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
    }
    return $2;
  }

  Expression _parseNonterminalPrimary(int $0, bool $1) {
    Expression $2;
    var $4 = _c;
    var $5 = _pos;
    for (;;) {
      var $7 = _parse_non_terminal_name(68, $1);
      if (_success) {
        var n = $7;
        Expression $$;
        $$ = NonterminalExpression(n);
        $2 = $$;
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      var $9 = _parse_terminal_name(70, $1);
      if (_success) {
        var n = $9;
        Expression $$;
        $$ = TerminalExpression(n);
        $2 = $$;
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      _parse_$LeftParenthesis(72, false);
      if (_success) {
        $2 = _parseNonterminalExpression(73, $1);
        if (_success) {
          _parse_$RightParenthesis(74, false);
        }
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  ProductionRule _parseTerminalDefinition(int $0, bool $1) {
    ProductionRule $2;
    var $4 = _c;
    var $5 = _pos;
    for (;;) {
      var $7 = _parseType(77, $1);
      if (_success) {
        var $8 = _parse_terminal_name(78, $1);
        if (_success) {
          _parse_$EqualSign(79, false);
          if (_success) {
            var $10 = _parseExpression(80, $1);
            if (_success) {
              _parse_$Semicolon(81, false);
              if (_success) {
                var t = $7;
                var n = $8;
                var e = $10;
                ProductionRule $$;
                $$ = ProductionRule(n, ProductionRuleKind.terminal, e, t);
                $2 = $$;
              }
            }
          }
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      var $13 = _parse_terminal_name(83, $1);
      if (_success) {
        _parse_$EqualSign(84, false);
        if (_success) {
          var $15 = _parseExpression(85, $1);
          if (_success) {
            _parse_$Semicolon(86, false);
            if (_success) {
              var n = $13;
              var e = $15;
              ProductionRule $$;
              $$ = ProductionRule(n, ProductionRuleKind.terminal, e, null);
              $2 = $$;
            }
          }
        }
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  OrderedChoiceExpression _parseExpression(int $0, bool $1) {
    if (_memoized(87, $0)) {
      return _mresult as OrderedChoiceExpression;
    }
    var $2 = _pos;
    OrderedChoiceExpression $3;
    var $5 = _c;
    var $6 = _pos;
    var $8 = _parseSequence(89, $1);
    if (_success) {
      List<SequenceExpression> $9;
      var $10 = _silence;
      _silence = true;
      if ($1) {
        $9 = [];
      }
      for (;;) {
        SequenceExpression $11;
        var $12 = _c;
        var $13 = _pos;
        _parse_$Slash(93, false);
        if (_success) {
          $11 = _parseSequence(94, $1);
        }
        if (!_success) {
          _c = $12;
          _pos = $13;
          break;
        }
        if ($1) {
          $9.add($11);
        }
      }
      _success = true;
      _silence = $10;
      if (_success) {
        var e = $8;
        var n = $9;
        OrderedChoiceExpression $$;
        $$ = OrderedChoiceExpression([e, ...n]);
        $3 = $$;
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    }
    if (_memoizable[$0] == true) {
      _memoize(87, $2, $3);
    }
    return $3;
  }

  SequenceExpression _parseSequence(int $0, bool $1) {
    if (_memoized(95, $0)) {
      return _mresult as SequenceExpression;
    }
    var $2 = _pos;
    SequenceExpression $3;
    var $5 = _c;
    var $6 = _pos;
    List<Expression> $8;
    if ($1) {
      $8 = [];
    }
    var $9 = false;
    for (;;) {
      var $10 = _parsePrefix(98, $1);
      if (!_success) {
        _success = $9;
        if (!_success) {
          $8 = null;
        }
        break;
      }
      if ($1) {
        $8.add($10);
      }
      $9 = true;
    }
    if (_success) {
      var $11 = _silence;
      _silence = true;
      var $12 = _parse_action(100, $1);
      _success = true;
      _silence = $11;
      if (_success) {
        var e = $8;
        var a = $12;
        SequenceExpression $$;
        $$ = SequenceExpression(e, a);
        $3 = $$;
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    }
    if (_memoizable[$0] == true) {
      _memoize(95, $2, $3);
    }
    return $3;
  }

  Expression _parsePrefix(int $0, bool $1) {
    Expression $2;
    var $4 = _c;
    var $5 = _pos;
    var $7 = _silence;
    _silence = true;
    var $8 = _parse_semantic_value(104, $1);
    _success = true;
    _silence = $7;
    var $9 = _silence;
    _silence = true;
    String $10;
    var $11 = _c;
    var $12 = _pos;
    for (;;) {
      $10 = _parse_$Ampersand(108, $1);
      if (_success) {
        break;
      } else {
        _c = $11;
        _pos = $12;
      }
      $10 = _parse_$ExclamationMark(110, $1);
      if (_success) {
      } else {
        _c = $11;
        _pos = $12;
      }
      break;
    }
    _success = true;
    _silence = $9;
    var $17 = _parseSuffix(111, $1);
    if (_success) {
      var s = $8;
      var p = $10;
      var e = $17;
      Expression $$;
      $$ = _prefix(p, e, s);
      $2 = $$;
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
    }
    return $2;
  }

  Expression _parseSuffix(int $0, bool $1) {
    Expression $2;
    var $4 = _c;
    var $5 = _pos;
    var $7 = _parsePrimary(114, $1);
    if (_success) {
      var $8 = _silence;
      _silence = true;
      String $9;
      var $10 = _c;
      var $11 = _pos;
      for (;;) {
        $9 = _parse_$QuestionMark(118, $1);
        if (_success) {
          break;
        } else {
          _c = $10;
          _pos = $11;
        }
        $9 = _parse_$Asterisk(120, $1);
        if (_success) {
          break;
        } else {
          _c = $10;
          _pos = $11;
        }
        $9 = _parse_$PlusSign(122, $1);
        if (_success) {
        } else {
          _c = $10;
          _pos = $11;
        }
        break;
      }
      _success = true;
      _silence = $8;
      if (_success) {
        var e = $7;
        var s = $9;
        Expression $$;
        $$ = _suffix(s, e);
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
    }
    return $2;
  }

  Expression _parsePrimary(int $0, bool $1) {
    Expression $2;
    var $4 = _c;
    var $5 = _pos;
    for (;;) {
      var $7 = _parse_sub_terminal_name(125, $1);
      if (_success) {
        var n = $7;
        Expression $$;
        $$ = SubterminalExpression(n);
        $2 = $$;
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      _parse_$LeftParenthesis(127, false);
      if (_success) {
        $2 = _parseExpression(128, $1);
        if (_success) {
          _parse_$RightParenthesis(129, false);
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      $2 = _parse_literal(131, $1);
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      $2 = _parse_character_class(133, $1);
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      _parse_$Period(135, $1);
      if (_success) {
        Expression $$;
        $$ = AnyCharacterExpression();
        $2 = $$;
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      _parse_$LessThanSign(137, false);
      if (_success) {
        var $20 = _parseExpression(138, $1);
        if (_success) {
          _parse_$GreaterThanSign(139, false);
          if (_success) {
            var e = $20;
            Expression $$;
            $$ = CaptureExpression(e);
            $2 = $$;
          }
        }
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  ProductionRule _parseSubterminalDefinition(int $0, bool $1) {
    ProductionRule $2;
    var $4 = _c;
    var $5 = _pos;
    for (;;) {
      var $7 = _parseType(142, $1);
      if (_success) {
        var $8 = _parse_sub_terminal_name(143, $1);
        if (_success) {
          _parse_$EqualSign(144, false);
          if (_success) {
            var $10 = _parseExpression(145, $1);
            if (_success) {
              _parse_$Semicolon(146, false);
              if (_success) {
                var t = $7;
                var n = $8;
                var e = $10;
                ProductionRule $$;
                $$ = ProductionRule(n, ProductionRuleKind.subterminal, e, t);
                $2 = $$;
              }
            }
          }
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      var $13 = _parse_sub_terminal_name(148, $1);
      if (_success) {
        _parse_$EqualSign(149, false);
        if (_success) {
          var $15 = _parseExpression(150, $1);
          if (_success) {
            _parse_$Semicolon(151, false);
            if (_success) {
              var n = $13;
              var e = $15;
              ProductionRule $$;
              $$ = ProductionRule(n, ProductionRuleKind.subterminal, e, null);
              $2 = $$;
            }
          }
        }
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  String _parseType(int $0, bool $1) {
    if (_memoized(152, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    var $5 = _c;
    var $6 = _pos;
    var $8 = _parseTypeName(154, $1);
    if (_success) {
      var $9 = _silence;
      _silence = true;
      List<String> $10;
      var $11 = _c;
      var $12 = _pos;
      _parse_$LessThanSign(158, false);
      if (_success) {
        $10 = _parseTypeArguments(159, $1);
        if (_success) {
          _parse_$GreaterThanSign(160, false);
        }
      }
      if (!_success) {
        _c = $11;
        _pos = $12;
      }
      _success = true;
      _silence = $9;
      if (_success) {
        var n = $8;
        var a = $10;
        String $$;
        $$ = n + (a == null ? '' : '<' + a.join(', ') + '>');
        $3 = $$;
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    }
    if (_memoizable[$0] == true) {
      _memoize(152, $2, $3);
    }
    return $3;
  }

  String _parseTypeName(int $0, bool $1) {
    String $2;
    var $4 = _c;
    var $5 = _pos;
    for (;;) {
      var $7 = _parse_library_prefix(163, $1);
      if (_success) {
        _parse_$Period(164, false);
        if (_success) {
          var $9 = _parse_type_name(165, $1);
          if (_success) {
            var p = $7;
            var n = $9;
            String $$;
            $$ = '$p.$n';
            $2 = $$;
          }
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      $2 = _parse_type_name(167, $1);
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  List<String> _parseTypeArguments(int $0, bool $1) {
    List<String> $2;
    var $4 = _c;
    var $5 = _pos;
    var $7 = _parseType(170, $1);
    if (_success) {
      List<String> $8;
      var $9 = _silence;
      _silence = true;
      if ($1) {
        $8 = [];
      }
      for (;;) {
        String $10;
        var $11 = _c;
        var $12 = _pos;
        _parse_$Comma(174, false);
        if (_success) {
          $10 = _parseType(175, $1);
        }
        if (!_success) {
          _c = $11;
          _pos = $12;
          break;
        }
        if ($1) {
          $8.add($10);
        }
      }
      _success = true;
      _silence = $9;
      if (_success) {
        var t = $7;
        var n = $8;
        List<String> $$;
        $$ = [t, ...n];
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
    }
    return $2;
  }

  String _parse_non_terminal_name(int $0, bool $1) {
    if (_memoized(176, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    $3 = _parse$$IDENTIFIER(178, $1);
    if (_success) {
      _parse$$SPACING(179, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'non terminal name\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(176, $2, $3);
    }
    return $3;
  }

  String _parse_terminal_name(int $0, bool $1) {
    if (_memoized(180, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    var $9 = _pos;
    var $10 = $1;
    $1 = false;
    var $12 = _c;
    var $13 = _pos;
    if (_c == 39) {
      _success = true;
      _c = _input[_pos += _c <= 65535 ? 1 : 2];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      var $17 = false;
      for (;;) {
        var $19 = _c;
        var $20 = _pos;
        var $22 = _c;
        var $23 = _pos;
        var $24 = _predicate;
        var $25 = _silence;
        var $26 = $1;
        _predicate = true;
        $1 = false;
        _silence = true;
        if (_c == 39) {
          _success = true;
          _c = _input[_pos += _c <= 65535 ? 1 : 2];
        } else {
          _success = false;
          if (!_silence && _fposEnd < _pos) {
            _fposEnd = _pos;
          }
        }
        _silence = $25;
        _c = $22;
        _pos = $23;
        _predicate = $24;
        _silence = $25;
        $1 = $26;
        _success = !_success;
        if (_success) {
          _parse$$TERMINAL_CHAR(191, false);
        }
        if (!_success) {
          _c = $19;
          _pos = $20;
          _success = $17;
          break;
        }
        $17 = true;
      }
      if (_success) {
        if (_c == 39) {
          _success = true;
          _c = _input[_pos += _c <= 65535 ? 1 : 2];
        } else {
          _success = false;
          if (!_silence && _fposEnd < _pos) {
            _fposEnd = _pos;
          }
        }
      }
    }
    if (!_success) {
      _c = $12;
      _pos = $13;
    } else {
      $3 = _text.substring($9, _pos);
    }
    $1 = $10;
    if (_success) {
      _parse$$SPACING(193, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'terminal name\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(180, $2, $3);
    }
    return $3;
  }

  String _parse_sub_terminal_name(int $0, bool $1) {
    if (_memoized(194, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    var $9 = _pos;
    var $10 = $1;
    $1 = false;
    var $12 = _c;
    var $13 = _pos;
    if (_c == 64) {
      _success = true;
      _c = _input[_pos += _c <= 65535 ? 1 : 2];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      _parse$$IDENTIFIER(200, false);
    }
    if (!_success) {
      _c = $12;
      _pos = $13;
    } else {
      $3 = _text.substring($9, _pos);
    }
    $1 = $10;
    if (_success) {
      _parse$$SPACING(201, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'sub terminal name\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(194, $2, $3);
    }
    return $3;
  }

  String _parse_semantic_value(int $0, bool $1) {
    if (_memoized(202, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    $3 = _parse$$IDENTIFIER(204, $1);
    if (_success) {
      if (_c == 58) {
        _success = true;
        _c = _input[++_pos];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'semantic value\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(202, $2, $3);
    }
    return $3;
  }

  String _parse_type_name(int $0, bool $1) {
    if (_memoized(206, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    var $9 = _pos;
    var $10 = $1;
    $1 = false;
    var $12 = _c;
    var $13 = _pos;
    _parse$$IDENTIFIER(211, false);
    if (_success) {
      var $16 = _silence;
      _silence = true;
      if (_c == 63) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      _success = true;
      _silence = $16;
    }
    if (!_success) {
      _c = $12;
      _pos = $13;
    } else {
      $3 = _text.substring($9, _pos);
    }
    $1 = $10;
    if (_success) {
      _parse$$SPACING(214, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'type name\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(206, $2, $3);
    }
    return $3;
  }

  String _parse_library_prefix(int $0, bool $1) {
    String $2;
    _fposEnd = -1;
    var $4 = _c;
    var $5 = _pos;
    var $8 = _pos;
    var $9 = $1;
    $1 = false;
    var $11 = _c;
    var $12 = _pos;
    var $14 = _silence;
    _silence = true;
    if (_c == 95) {
      _success = true;
      _c = _input[_pos += _c <= 65535 ? 1 : 2];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    _success = true;
    _silence = $14;
    _parse$$IDENTIFIER(222, false);
    if (!_success) {
      _c = $11;
      _pos = $12;
    } else {
      $2 = _text.substring($8, _pos);
    }
    $1 = $9;
    if (!_success) {
      _c = $4;
      _pos = $5;
      if (!_silence) {
        _fail($5, '\'library prefix\'');
      }
    }
    return $2;
  }

  String _parse_$Semicolon(int $0, bool $1) {
    if (_memoized(223, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 59) {
      _success = true;
      $3 = ';';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      _parse$$SPACING(226, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\';\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(223, $2, $3);
    }
    return $3;
  }

  String _parse_action(int $0, bool $1) {
    if (_memoized(227, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 123) {
      _success = true;
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      var $10 = _pos;
      var $11 = $1;
      $1 = false;
      var $13 = _c;
      var $14 = _pos;
      var $17 = _silence;
      _silence = true;
      for (;;) {
        _parse$$ACTION_BODY(234, false);
        if (!_success) {
          break;
        }
      }
      _success = true;
      _silence = $17;
      if (!_success) {
        _c = $13;
        _pos = $14;
      } else {
        $3 = _text.substring($10, _pos);
      }
      $1 = $11;
      if (_c == 125) {
        _success = true;
        _c = _input[++_pos];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        _parse$$SPACING(236, false);
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'action\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(227, $2, $3);
    }
    return $3;
  }

  String _parse_$Ampersand(int $0, bool $1) {
    if (_memoized(237, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 38) {
      _success = true;
      $3 = '&';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      _parse$$SPACING(240, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'&\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(237, $2, $3);
    }
    return $3;
  }

  Expression _parse_character_class(int $0, bool $1) {
    Expression $2;
    _fposEnd = -1;
    var $4 = _c;
    var $5 = _pos;
    if (_c == 91) {
      _success = true;
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      List<List<int>> $8;
      if ($1) {
        $8 = [];
      }
      var $9 = false;
      for (;;) {
        List<int> $10;
        var $11 = _c;
        var $12 = _pos;
        var $14 = _c;
        var $15 = _pos;
        var $16 = _predicate;
        var $17 = _silence;
        var $18 = $1;
        _predicate = true;
        $1 = false;
        _silence = true;
        if (_c == 93) {
          _success = true;
          _c = _input[++_pos];
        } else {
          _success = false;
          if (!_silence && _fposEnd < _pos) {
            _fposEnd = _pos;
          }
        }
        _silence = $17;
        _c = $14;
        _pos = $15;
        _predicate = $16;
        _silence = $17;
        $1 = $18;
        _success = !_success;
        if (_success) {
          $10 = _parse$$RANGE(249, $1);
        }
        if (!_success) {
          _c = $11;
          _pos = $12;
          _success = $9;
          if (!_success) {
            $8 = null;
          }
          break;
        }
        if ($1) {
          $8.add($10);
        }
        $9 = true;
      }
      if (_success) {
        if (_c == 93) {
          _success = true;
          _c = _input[++_pos];
        } else {
          _success = false;
          if (!_silence && _fposEnd < _pos) {
            _fposEnd = _pos;
          }
        }
        if (_success) {
          _parse$$SPACING(251, false);
          if (_success) {
            var r = $8;
            Expression $$;
            $$ = CharacterClassExpression(r);
            $2 = $$;
          }
        }
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
      if (!_silence) {
        _fail($5, '\'character class\'');
      }
    }
    return $2;
  }

  String _parse_$RightParenthesis(int $0, bool $1) {
    if (_memoized(252, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 41) {
      _success = true;
      $3 = ')';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      _parse$$SPACING(255, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\')\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(252, $2, $3);
    }
    return $3;
  }

  String _parse_$Period(int $0, bool $1) {
    if (_memoized(256, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 46) {
      _success = true;
      $3 = '.';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      _parse$$SPACING(259, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'.\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(256, $2, $3);
    }
    return $3;
  }

  dynamic _parse_end_of_file(int $0, bool $1) {
    dynamic $2;
    _fposEnd = -1;
    var $4 = _c;
    var $5 = _pos;
    var $7 = _c;
    var $8 = _pos;
    var $9 = _predicate;
    var $10 = _silence;
    var $11 = $1;
    _predicate = true;
    $1 = false;
    _silence = true;
    if (_c < _eof) {
      _success = true;
      _c = _input[_pos += _c <= 65535 ? 1 : 2];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    _silence = $10;
    _c = $7;
    _pos = $8;
    _predicate = $9;
    _silence = $10;
    $1 = $11;
    _success = !_success;
    if (!_success) {
      _c = $4;
      _pos = $5;
      if (!_silence) {
        _fail($5, '\'end of file\'');
      }
    }
    return $2;
  }

  String _parse_globals(int $0, bool $1) {
    String $2;
    _fposEnd = -1;
    var $4 = _c;
    var $5 = _pos;
    if (_c == 37) {
      _success = true;
      _matchString('%{');
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      var $9 = _pos;
      var $10 = $1;
      $1 = false;
      var $12 = _c;
      var $13 = _pos;
      var $16 = _silence;
      _silence = true;
      for (;;) {
        _parse$$GLOBALS_BODY(271, false);
        if (!_success) {
          break;
        }
      }
      _success = true;
      _silence = $16;
      if (!_success) {
        _c = $12;
        _pos = $13;
      } else {
        $2 = _text.substring($9, _pos);
      }
      $1 = $10;
      if (_c == 125) {
        _success = true;
        _matchString('}%');
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        _parse$$SPACING(273, false);
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
      if (!_silence) {
        _fail($5, '\'globals\'');
      }
    }
    return $2;
  }

  List _parse_leading_spaces(int $0, bool $1) {
    List $2;
    _fposEnd = -1;
    var $4 = _c;
    var $5 = _pos;
    $2 = _parse$$SPACING(276, false);
    if (!_success) {
      _c = $4;
      _pos = $5;
      if (!_silence) {
        _fail($5, '\'leading spaces\'');
      }
    }
    return $2;
  }

  String _parse_$EqualSign(int $0, bool $1) {
    if (_memoized(277, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 61) {
      _success = true;
      $3 = '=';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      _parse$$SPACING(280, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'=\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(277, $2, $3);
    }
    return $3;
  }

  Expression _parse_literal(int $0, bool $1) {
    Expression $2;
    _fposEnd = -1;
    var $4 = _c;
    var $5 = _pos;
    if (_c == 34) {
      _success = true;
      _c = _input[_pos += _c <= 65535 ? 1 : 2];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      List<int> $8;
      var $9 = _silence;
      _silence = true;
      if ($1) {
        $8 = [];
      }
      for (;;) {
        int $10;
        var $11 = _c;
        var $12 = _pos;
        var $14 = _c;
        var $15 = _pos;
        var $16 = _predicate;
        var $17 = _silence;
        var $18 = $1;
        _predicate = true;
        $1 = false;
        _silence = true;
        if (_c == 34) {
          _success = true;
          _c = _input[_pos += _c <= 65535 ? 1 : 2];
        } else {
          _success = false;
          if (!_silence && _fposEnd < _pos) {
            _fposEnd = _pos;
          }
        }
        _silence = $17;
        _c = $14;
        _pos = $15;
        _predicate = $16;
        _silence = $17;
        $1 = $18;
        _success = !_success;
        if (_success) {
          $10 = _parse$$LITERAL_CHAR(289, $1);
        }
        if (!_success) {
          _c = $11;
          _pos = $12;
          break;
        }
        if ($1) {
          $8.add($10);
        }
      }
      _success = true;
      _silence = $9;
      if (_c == 34) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        _parse$$SPACING(291, false);
        if (_success) {
          var c = $8;
          Expression $$;
          $$ = LiteralExpression(String.fromCharCodes(c));
          $2 = $$;
        }
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
      if (!_silence) {
        _fail($5, '\'literal\'');
      }
    }
    return $2;
  }

  String _parse_members(int $0, bool $1) {
    String $2;
    _fposEnd = -1;
    var $4 = _c;
    var $5 = _pos;
    if (_c == 123) {
      _success = true;
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      var $9 = _pos;
      var $10 = $1;
      $1 = false;
      var $12 = _c;
      var $13 = _pos;
      var $16 = _silence;
      _silence = true;
      for (;;) {
        _parse$$ACTION_BODY(299, false);
        if (!_success) {
          break;
        }
      }
      _success = true;
      _silence = $16;
      if (!_success) {
        _c = $12;
        _pos = $13;
      } else {
        $2 = _text.substring($9, _pos);
      }
      $1 = $10;
      if (_c == 125) {
        _success = true;
        _c = _input[++_pos];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        _parse$$SPACING(301, false);
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
      if (!_silence) {
        _fail($5, '\'members\'');
      }
    }
    return $2;
  }

  String _parse_$ExclamationMark(int $0, bool $1) {
    if (_memoized(302, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 33) {
      _success = true;
      $3 = '!';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      _parse$$SPACING(305, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'!\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(302, $2, $3);
    }
    return $3;
  }

  String _parse_$LeftParenthesis(int $0, bool $1) {
    if (_memoized(306, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 40) {
      _success = true;
      $3 = '(';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      _parse$$SPACING(309, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'(\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(306, $2, $3);
    }
    return $3;
  }

  String _parse_$PlusSign(int $0, bool $1) {
    if (_memoized(310, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 43) {
      _success = true;
      $3 = '+';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      _parse$$SPACING(313, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'+\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(310, $2, $3);
    }
    return $3;
  }

  String _parse_$Comma(int $0, bool $1) {
    String $2;
    _fposEnd = -1;
    var $4 = _c;
    var $5 = _pos;
    if (_c == 44) {
      _success = true;
      $2 = ',';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      _parse$$SPACING(317, false);
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
      if (!_silence) {
        _fail($5, '\',\'');
      }
    }
    return $2;
  }

  String _parse_$QuestionMark(int $0, bool $1) {
    if (_memoized(318, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 63) {
      _success = true;
      $3 = '?';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      _parse$$SPACING(321, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'?\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(318, $2, $3);
    }
    return $3;
  }

  String _parse_$Slash(int $0, bool $1) {
    if (_memoized(322, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 47) {
      _success = true;
      $3 = '/';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      _parse$$SPACING(325, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'/\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(322, $2, $3);
    }
    return $3;
  }

  String _parse_$Asterisk(int $0, bool $1) {
    if (_memoized(326, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 42) {
      _success = true;
      $3 = '*';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      _parse$$SPACING(329, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'*\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(326, $2, $3);
    }
    return $3;
  }

  String _parse_$LessThanSign(int $0, bool $1) {
    if (_memoized(330, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 60) {
      _success = true;
      $3 = '<';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      _parse$$SPACING(333, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'<\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(330, $2, $3);
    }
    return $3;
  }

  String _parse_$GreaterThanSign(int $0, bool $1) {
    if (_memoized(334, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    _fposEnd = -1;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 62) {
      _success = true;
      $3 = '>';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      _parse$$SPACING(337, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (!_silence) {
        _fail($6, '\'>\'');
      }
    }
    if (_memoizable[$0] == true) {
      _memoize(334, $2, $3);
    }
    return $3;
  }

  dynamic _parse$$ACTION_BODY(int $0, bool $1) {
    if (_memoized(338, $0)) {
      return _mresult as dynamic;
    }
    var $2 = _pos;
    dynamic $3;
    var $5 = _c;
    var $6 = _pos;
    for (;;) {
      if (_c == 123) {
        _success = true;
        $3 = '{';
        _c = _input[++_pos];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        var $10 = _silence;
        _silence = true;
        for (;;) {
          _parse$$ACTION_BODY(342, false);
          if (!_success) {
            break;
          }
        }
        _success = true;
        _silence = $10;
        if (_c == 125) {
          _success = true;
          _c = _input[++_pos];
        } else {
          _success = false;
          if (!_silence && _fposEnd < _pos) {
            _fposEnd = _pos;
          }
        }
      }
      if (_success) {
        break;
      } else {
        _c = $5;
        _pos = $6;
      }
      var $14 = _c;
      var $15 = _pos;
      var $16 = _predicate;
      var $17 = _silence;
      var $18 = $1;
      _predicate = true;
      $1 = false;
      _silence = true;
      if (_c == 125) {
        _success = true;
        _c = _input[++_pos];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      _silence = $17;
      _c = $14;
      _pos = $15;
      _predicate = $16;
      _silence = $17;
      $1 = $18;
      _success = !_success;
      if (_success) {
        if (_c < _eof) {
          _success = true;
          _c = _input[_pos += _c <= 65535 ? 1 : 2];
        } else {
          _success = false;
          if (!_silence && _fposEnd < _pos) {
            _fposEnd = _pos;
          }
        }
      }
      if (_success) {
      } else {
        _c = $5;
        _pos = $6;
      }
      break;
    }
    if (_memoizable[$0] == true) {
      _memoize(338, $2, $3);
    }
    return $3;
  }

  String _parse$$COMMENT(int $0, bool $1) {
    String $2;
    var $4 = _c;
    var $5 = _pos;
    if (_c == 35) {
      _success = true;
      $2 = '#';
      _c = _input[++_pos];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      var $9 = _silence;
      _silence = true;
      for (;;) {
        var $11 = _c;
        var $12 = _pos;
        var $14 = _c;
        var $15 = _pos;
        var $16 = _predicate;
        var $17 = _silence;
        var $18 = $1;
        _predicate = true;
        $1 = false;
        _silence = true;
        _parse$$EOL(355, false);
        _silence = $17;
        _c = $14;
        _pos = $15;
        _predicate = $16;
        _silence = $17;
        $1 = $18;
        _success = !_success;
        if (_success) {
          if (_c < _eof) {
            _success = true;
            _c = _input[_pos += _c <= 65535 ? 1 : 2];
          } else {
            _success = false;
            if (!_silence && _fposEnd < _pos) {
              _fposEnd = _pos;
            }
          }
        }
        if (!_success) {
          _c = $11;
          _pos = $12;
          break;
        }
      }
      _success = true;
      _silence = $9;
      var $22 = _silence;
      _silence = true;
      _parse$$EOL(358, false);
      _success = true;
      _silence = $22;
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
    }
    return $2;
  }

  dynamic _parse$$EOL(int $0, bool $1) {
    if (_memoized(359, $0)) {
      return _mresult as dynamic;
    }
    var $2 = _pos;
    dynamic $3;
    var $5 = _c;
    var $6 = _pos;
    for (;;) {
      if (_c == 13) {
        _success = true;
        $3 = _matchString('\r\n');
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        break;
      } else {
        _c = $5;
        _pos = $6;
      }
      if (_c == 10 || _c == 13) {
        _success = true;
        $3 = _c;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
      } else {
        _c = $5;
        _pos = $6;
      }
      break;
    }
    if (_memoizable[$0] == true) {
      _memoize(359, $2, $3);
    }
    return $3;
  }

  dynamic _parse$$GLOBALS_BODY(int $0, bool $1) {
    dynamic $2;
    var $4 = _c;
    var $5 = _pos;
    var $7 = _c;
    var $8 = _pos;
    var $9 = _predicate;
    var $10 = _silence;
    var $11 = $1;
    _predicate = true;
    $1 = false;
    _silence = true;
    if (_c == 125) {
      _success = true;
      _matchString('}%');
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    _silence = $10;
    _c = $7;
    _pos = $8;
    _predicate = $9;
    _silence = $10;
    $1 = $11;
    _success = !_success;
    if (_success) {
      if (_c < _eof) {
        _success = true;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
    }
    return $2;
  }

  int _parse$$HEX_NUMBER(int $0, bool $1) {
    if (_memoized(369, $0)) {
      return _mresult as int;
    }
    var $2 = _pos;
    int $3;
    var $5 = _c;
    var $6 = _pos;
    if (_c == 92) {
      _success = true;
      _c = _input[_pos += _c <= 65535 ? 1 : 2];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (_success) {
      if (_c == 117) {
        _success = true;
        _c = _input[++_pos];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        String $10;
        var $11 = _pos;
        var $12 = $1;
        $1 = false;
        var $14 = _c;
        var $15 = _pos;
        var $18 = false;
        for (;;) {
          if (_c >= 48 && _c <= 57 ||
              _c >= 65 && _c <= 70 ||
              _c >= 97 && _c <= 102) {
            _success = true;
            _c = _input[_pos += _c <= 65535 ? 1 : 2];
          } else {
            _success = false;
            if (!_silence && _fposEnd < _pos) {
              _fposEnd = _pos;
            }
          }
          if (!_success) {
            _success = $18;
            break;
          }
          $18 = true;
        }
        if (!_success) {
          _c = $14;
          _pos = $15;
        } else {
          $10 = _text.substring($11, _pos);
        }
        $1 = $12;
        if (_success) {
          var d = $10;
          int $$;
          $$ = int.parse(d, radix: 16);
          $3 = $$;
        }
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    }
    if (_memoizable[$0] == true) {
      _memoize(369, $2, $3);
    }
    return $3;
  }

  String _parse$$IDENTIFIER(int $0, bool $1) {
    if (_memoized(378, $0)) {
      return _mresult as String;
    }
    var $2 = _pos;
    String $3;
    var $5 = _c;
    var $6 = _pos;
    var $9 = _pos;
    var $10 = $1;
    $1 = false;
    var $12 = _c;
    var $13 = _pos;
    _parse$$IDENT_START(383, false);
    if (_success) {
      var $17 = _silence;
      _silence = true;
      for (;;) {
        _parse$$IDENT_CONT(385, false);
        if (!_success) {
          break;
        }
      }
      _success = true;
      _silence = $17;
    }
    if (!_success) {
      _c = $12;
      _pos = $13;
    } else {
      $3 = _text.substring($9, _pos);
    }
    $1 = $10;
    if (!_success) {
      _c = $5;
      _pos = $6;
    }
    if (_memoizable[$0] == true) {
      _memoize(378, $2, $3);
    }
    return $3;
  }

  int _parse$$IDENT_CONT(int $0, bool $1) {
    int $2;
    var $4 = _c;
    var $5 = _pos;
    for (;;) {
      $2 = _parse$$IDENT_START(388, false);
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      if (_c >= 48 && _c <= 57 || _c == 95) {
        _success = true;
        $2 = _c;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  int _parse$$IDENT_START(int $0, bool $1) {
    if (_memoized(391, $0)) {
      return _mresult as int;
    }
    var $2 = _pos;
    int $3;
    var $5 = _c;
    var $6 = _pos;
    if (_c >= 65 && _c <= 90 || _c >= 97 && _c <= 122) {
      _success = true;
      $3 = _c;
      _c = _input[_pos += _c <= 65535 ? 1 : 2];
    } else {
      _success = false;
      if (!_silence && _fposEnd < _pos) {
        _fposEnd = _pos;
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    }
    if (_memoizable[$0] == true) {
      _memoize(391, $2, $3);
    }
    return $3;
  }

  int _parse$$LITERAL_CHAR(int $0, bool $1) {
    int $2;
    var $4 = _c;
    var $5 = _pos;
    for (;;) {
      if (_c == 92) {
        _success = true;
        _c = _input[++_pos];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        int $8;
        if (_c == 34 || _c == 92 || _c == 110 || _c == 114 || _c == 116) {
          _success = true;
          $8 = _c;
          _c = _input[_pos += _c <= 65535 ? 1 : 2];
        } else {
          _success = false;
          if (!_silence && _fposEnd < _pos) {
            _fposEnd = _pos;
          }
        }
        if (_success) {
          var c = $8;
          int $$;
          $$ = _escape(c);
          $2 = $$;
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      $2 = _parse$$HEX_NUMBER(399, $1);
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      var $12 = _c;
      var $13 = _pos;
      var $14 = _predicate;
      var $15 = _silence;
      var $16 = $1;
      _predicate = true;
      $1 = false;
      _silence = true;
      if (_c == 92) {
        _success = true;
        _c = _input[++_pos];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      _silence = $15;
      _c = $12;
      _pos = $13;
      _predicate = $14;
      _silence = $15;
      $1 = $16;
      _success = !_success;
      if (_success) {
        var $19 = _c;
        var $20 = _pos;
        var $21 = _predicate;
        var $22 = _silence;
        var $23 = $1;
        _predicate = true;
        $1 = false;
        _silence = true;
        _parse$$EOL(404, false);
        _silence = $22;
        _c = $19;
        _pos = $20;
        _predicate = $21;
        _silence = $22;
        $1 = $23;
        _success = !_success;
        if (_success) {
          if (_c < _eof) {
            _success = true;
            $2 = _c;
            _c = _input[_pos += _c <= 65535 ? 1 : 2];
          } else {
            _success = false;
            if (!_silence && _fposEnd < _pos) {
              _fposEnd = _pos;
            }
          }
        }
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  List<int> _parse$$RANGE(int $0, bool $1) {
    List<int> $2;
    var $4 = _c;
    var $5 = _pos;
    for (;;) {
      var $7 = _parse$$RANGE_CHAR(408, $1);
      if (_success) {
        if (_c == 45) {
          _success = true;
          _c = _input[++_pos];
        } else {
          _success = false;
          if (!_silence && _fposEnd < _pos) {
            _fposEnd = _pos;
          }
        }
        if (_success) {
          var $9 = _parse$$RANGE_CHAR(410, $1);
          if (_success) {
            var s = $7;
            var e = $9;
            List<int> $$;
            $$ = [s, e];
            $2 = $$;
          }
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      var $11 = _parse$$RANGE_CHAR(412, $1);
      if (_success) {
        var c = $11;
        List<int> $$;
        $$ = [c, c];
        $2 = $$;
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  int _parse$$RANGE_CHAR(int $0, bool $1) {
    if (_memoized(413, $0)) {
      return _mresult as int;
    }
    var $2 = _pos;
    int $3;
    var $5 = _c;
    var $6 = _pos;
    for (;;) {
      if (_c == 92) {
        _success = true;
        _c = _input[++_pos];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        int $9;
        if (_c == 45 ||
            _c >= 92 && _c <= 93 ||
            _c == 110 ||
            _c == 114 ||
            _c == 116) {
          _success = true;
          $9 = _c;
          _c = _input[_pos += _c <= 65535 ? 1 : 2];
        } else {
          _success = false;
          if (!_silence && _fposEnd < _pos) {
            _fposEnd = _pos;
          }
        }
        if (_success) {
          var c = $9;
          int $$;
          $$ = _escape(c);
          $3 = $$;
        }
      }
      if (_success) {
        break;
      } else {
        _c = $5;
        _pos = $6;
      }
      $3 = _parse$$HEX_NUMBER(418, $1);
      if (_success) {
        break;
      } else {
        _c = $5;
        _pos = $6;
      }
      var $13 = _c;
      var $14 = _pos;
      var $15 = _predicate;
      var $16 = _silence;
      var $17 = $1;
      _predicate = true;
      $1 = false;
      _silence = true;
      if (_c == 92) {
        _success = true;
        _c = _input[++_pos];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      _silence = $16;
      _c = $13;
      _pos = $14;
      _predicate = $15;
      _silence = $16;
      $1 = $17;
      _success = !_success;
      if (_success) {
        var $20 = _c;
        var $21 = _pos;
        var $22 = _predicate;
        var $23 = _silence;
        var $24 = $1;
        _predicate = true;
        $1 = false;
        _silence = true;
        _parse$$EOL(423, false);
        _silence = $23;
        _c = $20;
        _pos = $21;
        _predicate = $22;
        _silence = $23;
        $1 = $24;
        _success = !_success;
        if (_success) {
          if (_c < _eof) {
            _success = true;
            $3 = _c;
            _c = _input[_pos += _c <= 65535 ? 1 : 2];
          } else {
            _success = false;
            if (!_silence && _fposEnd < _pos) {
              _fposEnd = _pos;
            }
          }
        }
      }
      if (_success) {
      } else {
        _c = $5;
        _pos = $6;
      }
      break;
    }
    if (_memoizable[$0] == true) {
      _memoize(413, $2, $3);
    }
    return $3;
  }

  dynamic _parse$$SPACE(int $0, bool $1) {
    dynamic $2;
    var $4 = _c;
    var $5 = _pos;
    for (;;) {
      if (_c == 9 || _c == 32) {
        _success = true;
        $2 = _c;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      $2 = _parse$$EOL(429, false);
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  List _parse$$SPACING(int $0, bool $1) {
    if (_memoized(430, $0)) {
      return _mresult as List;
    }
    var $2 = _pos;
    List $3;
    var $5 = _c;
    var $6 = _pos;
    var $9 = _silence;
    _silence = true;
    for (;;) {
      var $11 = _c;
      var $12 = _pos;
      for (;;) {
        _parse$$SPACE(435, false);
        if (_success) {
          break;
        } else {
          _c = $11;
          _pos = $12;
        }
        _parse$$COMMENT(437, false);
        if (_success) {
        } else {
          _c = $11;
          _pos = $12;
        }
        break;
      }
      if (!_success) {
        break;
      }
    }
    _success = true;
    _silence = $9;
    if (!_success) {
      _c = $5;
      _pos = $6;
    }
    if (_memoizable[$0] == true) {
      _memoize(430, $2, $3);
    }
    return $3;
  }

  int _parse$$TERMINAL_CHAR(int $0, bool $1) {
    int $2;
    var $4 = _c;
    var $5 = _pos;
    for (;;) {
      if (_c == 47) {
        _success = true;
        _matchString('//');
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
        if (_c == 39) {
          _success = true;
          $2 = _c;
          _c = _input[_pos += _c <= 65535 ? 1 : 2];
        } else {
          _success = false;
          if (!_silence && _fposEnd < _pos) {
            _fposEnd = _pos;
          }
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      if (_c >= 32 && _c <= 38 || _c >= 40 && _c <= 126) {
        _success = true;
        $2 = _c;
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _success = false;
        if (!_silence && _fposEnd < _pos) {
          _fposEnd = _pos;
        }
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }
}

class _Memo {
  final int id;

  final int pos;

  final result;

  final bool success;

  _Memo({
    this.id,
    this.pos,
    this.result,
    this.success,
  });
}
// ignore_for_file: prefer_final_locals
// ignore_for_file: unused_element
// ignore_for_file: unused_field
// ignore_for_file: unused_local_variable
